﻿@using Microsoft.Extensions.Localization
@using System.ComponentModel.DataAnnotations
@using System.IO
@using ElectronNET.API
@using ElectronNET.API.Entities
@using OTaskForce.Singletons

@inject NavigationManager _navigationManager
@inject IStringLocalizer<CreateProjectModal> _localizer
@inject ProjectsOperator _projectsOperator

<div class="modal fade" id="CreateProjectModal" tabindex="-1">
    <div class="modal-dialog modal-dialog-centered modal-dialog-scrollable">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">@_localizer["Створити проєкт"]</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal"></button>
            </div>
            <EditForm Model="@_model" OnInvalidSubmit="@HandleInvalidSubmit" OnValidSubmit="@HandleValidSubmitAsync">
                <DataAnnotationsValidator />
                <div class="modal-body">
                    @* Project name input box *@
                    <div class="mb-3">
                        <label class="form-label">@_localizer["Назва проєкту"]</label>

                        <InputText @bind-Value="_model.ProjectTitle" class="form-control" placeholder="Hello world"/>

                        <div class="form-text">@_localizer["Назва проєкту може містити лише букви латинського алфавіту, цифри і деякі спеціальні символи"]</div>
                        <div class="invalid-feedback"><ValidationMessage For="@(() => _model.ProjectTitle)"/></div>
                    </div>
                    @* /Project name input box *@
                    
                    @* Project path input box *@
                    <div class="mb-0">
                        <label class="form-label">@_localizer["Розташування проєкту"]</label>

                        <div class="input-group">
                            <InputText @bind-Value="_model.ProjectParentDirectoryPath" class="form-control" readonly/>
                            <button class="btn btn-secondary" type="button" @onclick="@SelectProjectDirectoryPathAsync">
                                <i class="fas fa-folder-open"></i>
                                <span>@_localizer["Огляд"]</span>
                            </button>
                        </div>

                        <div class="form-text">@_localizer["Вкажіть шлях до директорії, у якій слід створити проєкт."]</div>
                        <div class="invalid-feedback"><ValidationMessage For="@(() => _model.ProjectParentDirectoryPath)"/></div>
                    </div>
                    @* /Project path input box *@
                </div>
                
                <div class="modal-footer d-flex justify-content-between">
                    <button type="button" class="btn btn-light border border-dark" data-bs-dismiss="modal">
                        <i class="fas fa-chevron-circle-left"></i>
                        <span>@_localizer["Відмінити"]</span>
                    </button>
                    <button type="submit" class="btn btn-dark" data-bs-dismiss="modal">
                        <span>@_localizer["Створити проєкт"]</span>
                        <i class="fas fa-chevron-circle-right"></i>
                    </button>
                </div>
            </EditForm>
        </div>
    </div>
</div>

@code
{
    private ProjectCreationModel _model;
    
    private class ProjectCreationModel
    {
        [Required, MinLength(1), MaxLength(100)]
        public string ProjectTitle { get; set; } = string.Empty;
        
        [Required, MinLength(1)]
        public string ProjectParentDirectoryPath { get; set; } = string.Empty;
    }

    protected override void OnInitialized()
    {
        _model = new ProjectCreationModel
        {
            ProjectTitle = string.Empty,
            ProjectParentDirectoryPath = _projectsOperator.DefaultProjectsDirectoryFullPath
        };
    }

    private void HandleInvalidSubmit()
    {
        Electron.Dialog.ShowErrorBox(
            _localizer["Помилка створення проєкту"],
            _localizer["Створення нового проєкту не було завершено через помилку у заповненні форми. Виправте допущені неточності і повторіть спробу!"]
        );
    }
    
    private async Task HandleValidSubmitAsync()
    {
        if (_model.ProjectTitle.IndexOfAny(Path.GetInvalidFileNameChars()) >= 0)
        {
            Electron.Dialog.ShowErrorBox(
                _localizer["Помилка створення проєкту"],
                _localizer["Запропонована вами назва проєкту містить недопустимі символи!"]
            );
            return;
        }
        
        try
        {
            await _projectsOperator.CreateNewProjectAsync(_model.ProjectParentDirectoryPath, _model.ProjectTitle);
        }
        catch (AccessViolationException)
        {
            Electron.Dialog.ShowErrorBox(
                _localizer["Помилка створення проєкту"],
                _localizer["Директорія зі вказаною назвою вже існує! Вигадайте інакшу назву для свого проєкту."]
            );
            return;
        }
        catch (Exception) { HandleInvalidSubmit(); }

        var projectFullPath = Path.Combine(_model.ProjectParentDirectoryPath, _model.ProjectTitle);

        if (!await _projectsOperator.CurrentProjectControl.TryOpenProjectAsync(projectFullPath))
        {
            Electron.Dialog.ShowErrorBox(
                _localizer["Помилка створення проєкту"],
                _localizer["Проєкт створено, але його файли було пошкоджено! Перевірте доступність файлової системи або зверніться до технічної підтримки."]
            );
            return;
        }
        
        _navigationManager.NavigateTo("/Project");
    }

    private async Task SelectProjectDirectoryPathAsync()
    {
        var mainWindow = Electron.WindowManager.BrowserWindows.First();
        var dialogResult = await Electron.Dialog.ShowOpenDialogAsync(mainWindow, new OpenDialogOptions
        {
            Properties = new[] { OpenDialogProperty.openDirectory },
            DefaultPath = _projectsOperator.DefaultProjectsDirectoryFullPath,
                    
            Title = _localizer["Оберіть шлях для збереження директорії проєкту..."],
            ButtonLabel = _localizer["Обрати розташування"]
        });
        
        if (dialogResult is { Length: > 0 } && Directory.Exists(dialogResult[0]))
            _model.ProjectParentDirectoryPath = dialogResult[0];
    }
}